const axios = require('axios');
const fs = require('fs');
const _ = require('lodash');
const WebSocket = require('ws');
var qrcode = require('qrcode-terminal');

console.log("SE CURTIR O NOSSO TRAMPO, NÃO DEIXE DE ENVIAR UM PIX PARA NUBANK@KORE.DEV.BR OU NO QRCODE ABAIXO");
console.log(" ");
console.log(" ");
console.log(" ");

qrcode.setErrorLevel('M');
qrcode.generate('http://sou1.dev.br',{small: true});

console.log(" ");
console.log(" ");
console.log(" ");


let config = JSON.parse(fs.readFileSync("conf.json"));

const instance = axios.create({
  baseURL: config.serverUrl+'/api',
  timeout: 30000,
  withCredentials: true,
  validateStatus: function (status) {
    return status < 300; // Resolve only if the status code is less than 500
  }
});


const params = new URLSearchParams();
      params.append('email', config.username);
      params.append('password', config.password);
      params.append('undefined', 'false');

let cookie = false;
let devices = [];
let positions = [];
let events = [];

instance.post('/session',params).then((r)=>{
	cookie = r.headers['set-cookie'];



	instance.get('/devices',{headers: {'cookie': cookie}}).then((d)=>{
		devices = d.data;

		console.log("carregados "+devices.length+" dispositivos");

		let wsServer = config.serverUrl.replace('http://','ws://').replace('https://','wss://');

		const ws = new WebSocket(wsServer+'/api/socket', {
  									headers: {
    										Cookie: cookie
  									}
				});

		ws.onopen = function(){
			console.log("ws open");
			setInterval(()=>{
				ws.send("[]");
			},5000);
		}


		ws.onclose = function(e){
			console.log(e);
		}

		ws.onmessage = function(d){
			let data = JSON.parse(d.data);

			if(data.events){
				//console.log(data.events);
			}else if(data.positions){
				data.positions.forEach((p)=>{
					let device = _.find(devices,{id: p.deviceId});
					let oldPositions = _.find(positions,{deviceId: p.deviceId});
					if(oldPositions){
						if(oldPositions.attributes['ignition'] && !p.attributes['ignition']){
							console.log(device.name+' desligou');

							var data = {"id":0,"description":"Novo...","deviceId":p.deviceId,"type":"custom","textChannel":false,"attributes":{"data":"LJDW#"}};


							instance.post('/commands/send',data,{headers: {'cookie': cookie}}).then((r)=>{
								console.log("LJDW ENVIADO");
							}).catch((r)=>{ console.log(r); });

						}else if(!oldPositions.attributes['ignition'] && p.attributes['ignition']){
							console.log(device.name+' ligou');
						}

						oldPositions.attributes['ignition'] = p.attributes['ignition'];
					}else{

						console.log("carregado "+device.name+" "+((p.attributes['ignition'])?'ligado':'desligado'));

						positions.push(p);
					}

				});
			}else{
				//console.log(data);
			}
		}

	});

});